{
************************************************************
 Programme prototype pour exprimentations sur port srie
 Aout 1998

 Version Delphi : Delphi 4

 Rmy Mallard
 25 rue de Provence
 78310 Maurepas - France

 Nota :
 Si vous possdez une version antrieure de Delphi (2 ou 3),
 vous pouvez rutiliser la majorit du code ci-dessous.
 Dernier point : le code peut bien sr tre amlior, et il y a
 peut tre des bugs qui m'ont chapps. Le code source est libre
 de droit, sauf si vous avez l'intention d'en utiliser tout ou
 partie pour un produit commercial. Dans ce cas, vous devrez
 demander l'autorisation crite  l'auteur.
************************************************************
}

unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, IniFiles, ComCtrls, Menus,

  AdPort, AdTerm, AdStatLt, AdPacket, OoMisc; {units AsyncPro}

type
  TForm1 = class(TForm)
    ApdComPort1: TApdComPort;
    Panel1: TPanel;
    cbComNum2: TComboBox;
    Label1: TLabel;
    cbBaud2: TComboBox;
    Label2: TLabel;
    LedPortOpen2: TApdStatusLight;
    Label3: TLabel;
    cbDataBits2: TComboBox;
    Label4: TLabel;
    cbParity2: TComboBox;
    Label5: TLabel;
    cbStopBits2: TComboBox;
    pnlTerm2: TPanel;
    Terminal2: TApdTerminal;
    ApdDataPacket1: TApdDataPacket;
    Panel3: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    LedPortOpen1: TApdStatusLight;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    LedRxStr1: TShape;
    btnRAZLed1: TSpeedButton;
    cbComNum1: TComboBox;
    cbBaud1: TComboBox;
    cbDataBits1: TComboBox;
    cbParity1: TComboBox;
    cbStopBits1: TComboBox;
    pnlTerm1: TPanel;
    Terminal1: TApdTerminal;
    cbRxStr1: TCheckBox;
    edWaitStr1: TEdit;
    ApdComPort2: TApdComPort;
    StatusBar1: TStatusBar;
    ApdEmulator1: TApdEmulator;
    ApdEmulator2: TApdEmulator;
    PopupMenuTerminal1: TPopupMenu;
    PopupMenuTerminal2: TPopupMenu;
    mnuEmul1None: TMenuItem;
    mnuEmul1ANSI: TMenuItem;
    mnuEmul1VT52: TMenuItem;
    mnuEmul1VT100: TMenuItem;
    mnuEmul2None: TMenuItem;
    mnuEmul2ANSI: TMenuItem;
    mnuEmul2VT52: TMenuItem;
    mnuEmul2VT100: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure cbComNum2Change(Sender: TObject);
    procedure edWaitStr1Change(Sender: TObject);
    procedure ApdDataPacket1StringPacket(Sender: TObject; Data: String);
    procedure btnRAZLed1Click(Sender: TObject);
    procedure cbComNum1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuEmul1NoneClick(Sender: TObject);
    procedure mnuEmul2NoneClick(Sender: TObject);
  private
    { Dclarations private }
    procedure SetTerminalSize;
    procedure SetComboBox;
    procedure InitValues(com: TApdComPort);
  public
    { Dclarations public }
  end;

const
  MsgErrSamePort = 'Les deux terminaux ne doivent pas avoir le mme numro de port.';
  MsgErrBadPort = 'Le port spcifi n''est pas valide.';

var
  Form1: TForm1;
  cheminApp, IniFile: string;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {cheminApp est une variable dans laquelle on place le nom du chemin d'accs
   partir duquel l'application a t lance}
  cheminApp := extractFilePath(application.exeName);

  {le fichier iniFile sera utilis pour stocker les informations relatives
  aux protocoles utiliss pour les ports RS232}
  iniFile := changeFileExt(application.exeName, '.ini');

  {utilisation du fichier iniFile pour rcuprer les informations relatives
  aux protocoles utiliss pour les ports RS232. Si le fichier n'existe pas,
  on dfinie des valeurs par dfaut. Ces informations sont utilises pour
  positionner les listes droulantes cbBauds, cbComNum, etc,  la bonne valeur}
  SetComboBox;

  {utilisation des valeurs de chacune des listes droulantes pour configurer
  chacun des deux ports srie}
  InitValues(ApdComPort1);
  InitValues(ApdComPort2);

  {La taille du terminal dpend de la fonte utilise et de la rsolution de l'cran
  de l'ordinateur de l'utilisateur. On s'arrange donc pour que la fentre des deux
  terminaux soit d'une taille raisonable, et surtout que toutes les donnes soient
  visibles}
  SetTerminalSize;
end;

procedure TForm1.SetTerminalSize;
begin
  {modification de la taille du terminal pour qu'il tienne juste dans le
  composant TPanel sur lequel il est plac. On est ainsi assur que tous
  les caractres reus seront visibles.
  On utilise pour cela les valeurs de hauteur et de largeur des caractres
  utiliss par les terminaux - CharWidth et CharHeight}
  with Terminal1 do begin
    repeat
      width := width - CharWidth;
    until (width < pnlTerm1.width);
    repeat
      Height := Height - CharHeight;
    until (Height < pnlTerm1.Height);
    forcePaint;
  end;
  with Terminal2 do begin
    repeat
      width := width - CharWidth;
    until (width < pnlTerm2.width);
    repeat
      Height := Height - CharHeight;
    until (Height < pnlTerm2.Height);
    forcePaint;
  end;
end;

procedure TForm1.SetComboBox;
var
  ini: TIniFile;
begin
  {utilisation du fichier iniFile pour rcuprer les informations relatives
  aux protocoles utiliss pour les ports RS232. Si le fichier n'existe pas,
  on dfinie des valeurs par dfaut. Ces informations sont utilises pour
  positionner les listes droulantes cbBauds, cbComNum, etc,  la bonne valeur}

  {les mthodes associes  l'objet TIniFile ne devraient normallement plus tre
  utilises que pour des raisons de compatibilit avec les application 16 bits
  qui faisaient un usage intense des fichiers ini. Dans l'environnement 32 bits
  de Win95 et WinNT, on devrait utiliser avec profit la base de registre.
  L'auteur pense cependant que la possibilit de voir les modifications apportes
  au fichier de configuration Ini est notablement simplifie, car visible dans
  un simple traitement de texte. Ceci dit, rien ne vous empche de modifier les
  portions de code concerne pour tirer partie de la base de registre du 32 bit.}
  ini := TIniFile.create(iniFile);

  {on lit donc les valeurs stockes dans le fichier ini, et on s'en sert pour
  positionner les boites listes sur le bon index.}
  cbBaud1.itemIndex := Ini.readInteger('PortOne', 'Baud', 4);
  cbBaud2.itemIndex := Ini.readInteger('PortTwo', 'Baud', 4);
  cbComNum1.itemIndex := Ini.readInteger('PortOne', 'ComNumber', 0);
  cbComNum2.itemIndex := Ini.readInteger('PortTwo', 'ComNumber', 1);
  cbDataBits1.itemIndex := Ini.readInteger('PortOne', 'DataBits', 2);
  cbDataBits2.itemIndex := Ini.readInteger('PortTwo', 'DataBits', 2);
  cbStopBits1.itemIndex := Ini.readInteger('PortOne', 'StopBits', 1);
  cbStopBits2.itemIndex := Ini.readInteger('PortTwo', 'StopBits', 1);
  cbParity1.itemIndex := Ini.readInteger('PortOne', 'Parity', 2);
  cbParity2.itemIndex := Ini.readInteger('PortTwo', 'Parity', 2);

  {libration des ressources alloues au composant TIniFile}
  ini.free;
end;

procedure TForm1.InitValues(com: TApdComPort);
var
  cbBaud, cbComNum, cbDataBits, cbStopBits, cbParity: TComboBox;
  led: TApdStatusLight;
  ini: TIniFile;
begin
  {dsignation des controles relatifs au port slectionn : on regarde la valeur
  du paramtre com transmis dans la procdure, et on dtermine ainsi quels boites
  liustes devront tre utilise pour paramtrer le port dsir}
  if (com.name = 'ApdComPort1') then begin
    cbBaud := cbBaud1;
    cbComNum := cbComNum1;
    cbDataBits := cbDataBits1;
    cbStopBits := cbStopBits1;
    cbParity := cbParity1;
    led := LedPortOpen1;
  end else if (com.name = 'ApdComPort2') then begin
    cbBaud := cbBaud2;
    cbComNum := cbComNum2;
    cbDataBits := cbDataBits2;
    cbStopBits := cbStopBits2;
    cbParity := cbParity2;
    led := LedPortOpen2;
  end;

  {modification des paramtres du port slectionn. Si un des paramtres n'est pas
  accpt, le port restera ferm et la led situe en haut  gauche du terminal
  restera en rouge pour indiquer que le port n'est plus accessible.}
  led.notLitColor := clRed;
  StatusBar1.panels[0].text := '';
  with com do begin

    {fermeture obligatoire du port avant de modifier ses proprits}
    AutoOpen := false;
    open := false;
    baud := strToInt(cbBaud.items[cbBaud.itemIndex]);
    comNumber := strToInt(cbComNum.items[cbComNum.itemIndex]);
    dataBits := strToInt(cbDataBits.items[cbDataBits.itemIndex]);
    StopBits := strToInt(cbStopBits.items[cbStopBits.itemIndex]);
    case cbParity.itemIndex of
      0 : parity := pEven;
      1 : parity := pMark;
      2 : parity := pNone;
      3 : parity := pOdd;
      4 : parity := pSpace;
    end;
    try

      {on essaye d'ouvrir le port avec les nouveaux paramtre}
      open := true;
    except

      {s'il y a un problme, on en informe l'utilisateur par un message d'erreur ...}
      if (cbComNum1.items[cbComNum1.itemIndex] = cbComNum2.items[cbComNum2.itemIndex]) then
        MessageDlg(MsgErrSamePort, mtWarning, [mbOK], 0)
      else MessageDlg(MsgErrBadPort, mtWarning, [mbOK], 0);

      {... et on ne va pas plus loin dans la procdure}
      exit;
    end;
  end;

  {si tout s'est bien pass on continue}
  led.notLitColor := clLime;

  {enregistrement des modifications dans le fichier ini}
  ini := TIniFile.create(iniFile);
  Ini.WriteInteger('PortOne', 'Baud', cbBaud1.itemIndex);
  Ini.WriteInteger('PortTwo', 'Baud', cbBaud2.itemIndex);
  Ini.WriteInteger('PortOne', 'ComNumber', cbComNum1.itemIndex);
  Ini.WriteInteger('PortTwo', 'ComNumber', cbComNum2.itemIndex);
  Ini.WriteInteger('PortOne', 'DataBits', cbDataBits1.itemIndex);
  Ini.WriteInteger('PortTwo', 'DataBits', cbDataBits2.itemIndex);
  Ini.WriteInteger('PortOne', 'StopBits', cbStopBits1.itemIndex);
  Ini.WriteInteger('PortTwo', 'StopBits', cbStopBits2.itemIndex);
  Ini.WriteInteger('PortOne', 'Parity', cbParity1.itemIndex);
  Ini.WriteInteger('PortTwo', 'Parity', cbParity2.itemIndex);
  ini.free;
end;

procedure TForm1.cbComNum1Change(Sender: TObject);
begin
  {procdure appele  chaque fois qu'un paramtre du port du terminal 1 change}
  InitValues(ApdComPort1);
end;

procedure TForm1.cbComNum2Change(Sender: TObject);
begin
  {procdure appele  chaque fois qu'un paramtre du port du terminal 2 change}
  InitValues(ApdComPort2);
end;

procedure TForm1.edWaitStr1Change(Sender: TObject);
begin
  {on met  jour le composant ApdDataPacket (de la librairie AsyncPro)
  destin  avertir quand la chaine qu'on spcifie dans sa proprit
  StartString arrive sur le port srie.}
  ApdDataPacket1.Enabled := false;
  ApdDataPacket1.startString := edWaitStr1.text;
  ApdDataPacket1.Enabled := true;
end;

procedure TForm1.ApdDataPacket1StringPacket(Sender: TObject; Data: String);
begin
  {rception de la chaine attendue sur terminal 1, on allume LedRxStr1 en vert}
  if cbRxStr1.checked then LedRxStr1.Brush.color := clLime;
end;

procedure TForm1.btnRAZLed1Click(Sender: TObject);
begin
  {on allume LedRxStr1 en gris ds qu'on appuis sur le bouton RAZ,
  et on est donc prt  tre averti ds que la chaine attendue
  sera reue sur le port srie }
  LedRxStr1.Brush.color := clGray;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {au moment de quitter l'application, on ferme les deux ports srie
  s'ils n'y taient pas}
  ApdComPort1.open := false;
  ApdComPort2.open := false;
end;

procedure TForm1.mnuEmul1NoneClick(Sender: TObject);
var
  i: integer;
begin
  {choix de l'mulation du terminal 1}

  {on dsactive la coche de toutes les options de menu}
  for i := 0 to PopupMenuTerminal1.items.count - 1 do begin
    PopupMenuTerminal1.items[i].checked := false;
  end;

  {on active la coche de l'options de menu slectionne}
  (sender as TMenuItem).checked := true;

  {en fonction de l'options de menu slectionne, on utilise l'mulation
  qui convient, pour le terminal 2}
  if mnuEmul1None.checked then ApdEmulator1.emulatorType := etNone
  else if mnuEmul1ANSI.checked then ApdEmulator1.emulatorType := etANSI
  else if mnuEmul1VT52.checked then ApdEmulator1.emulatorType := etVT52
  else if mnuEmul1VT100.checked then ApdEmulator1.emulatorType := etVT100;
end;

procedure TForm1.mnuEmul2NoneClick(Sender: TObject);
var
  i: integer;
begin
  {choix de l'mulation du terminal 2}

  {on dsactive la coche de toutes les options de menu}
  for i := 0 to PopupMenuTerminal2.items.count - 1 do begin
    PopupMenuTerminal2.items[i].checked := false;
  end;

  {on active la coche de l'options de menu slectionne}
  (sender as TMenuItem).checked := true;

  {en fonction de l'options de menu slectionne, on utilise l'mulation
  qui convient, pour le terminal 2}
  if mnuEmul2None.checked then ApdEmulator2.emulatorType := etNone
  else if mnuEmul2ANSI.checked then ApdEmulator2.emulatorType := etANSI
  else if mnuEmul2VT52.checked then ApdEmulator2.emulatorType := etVT52
  else if mnuEmul2VT100.checked then ApdEmulator2.emulatorType := etVT100;
end;

end.
